<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml" xmlns:th="http://www.thymeleaf.org" data-wf-page="5f1678e5cab089a2ba94fa45" data-wf-site="5f1678e5cab0894c6994fa44" lang="">
<head th:replace="pages/section/header :: header(title='RUNENVIKU')"></head>
<body class="body" style="    background-color: #FFFFFF;">
    <style>
        .body-context {
            text-align: justify;
            font-size: 16px;
            margin-top: 30px;
            line-height: 25px;
        }

        /* Set the size of the div element that contains the map */
        #map {
            height: 640px;  /* The height is 400 pixels */
            width: 100%;  /* The width is the width of the web page */
        }

        option {
            font-size: 20px;
        }

        @media only screen and (max-width: 768px) {
            .show-mobile {
                display: block;
            }

            .show-desktop {
                display: none;
            }
        }

        @media only screen and (min-width: 768px) {
            .collapseExample {
                display: none;
            }

            .collapse.dont-collapse-sm {
                display: block;
                height: auto !important;
                visibility: visible;
            }

        }
    </style>

    <div th:replace="pages/section/navbar :: navbar"></div>
    <hr style="border-top: 8px solid rgb(41 49 38);">

    <button class="btn btn-primary hidden visible-xs collapseExample" type="button" data-toggle="collapse" data-target="#collapseExample" aria-expanded="false" aria-controls="collapseExample" style="margin-left: 15px;">
        ตัวกรอง
    </button>

    <div class="container-fluid " style="margin-top: 20px">
        <div class="row">
            <div id="collapseExample" class="col-12 col-xl-3 col-lg-4 col-md-4 collapse dont-collapse-sm">
                <form class="todo-search">
                    <label style="font-size: 24px; margin-bottom: 0px">ตำแหน่งเก็บตัวอย่าง</label>
                    <div class="form-group">
                        <label for="">จังหวัด</label>
                        <select class="form-control" id="provinceSelected" name="provinceSelected" onchange="getDistrict()">
                            <option th:value="all" th:text="ทั้งหมด"></option>
                            <option th:each="province : ${provinces}" th:value="${province}" th:text="${province}">
                            </option>
                        </select>
                    </div>
                    <div class="form-group">
                        <label for="">อำเภอ</label>
                        <select class="form-control" id="districtSelected" name="districtSelected" onchange="getTambon()">
                            <option th:value="all" th:text="ทั้งหมด"></option>
                            <option th:each="district : ${districts}" th:value="${district}" th:text="${district}">
                            </option>
                        </select>
                    </div>
                    <div class="form-group">
                        <label for="">ตำบล</label>
                        <select class="form-control" id="tambonSelected" name="tambonSelected" onchange="initMap()">
                            <option th:value="all" th:text="ทั้งหมด"></option>
                            <option th:each="tambon : ${tambons}" th:value="${tambon}" th:text="${tambon}">
                            </option>
                        </select>
                    </div>
                </form>

                <form class="todo-search" style="margin-top: 10px">
                    <div class="form-group">
                        <label for="">ฤดู</label>
                        <select class="form-control" id="seasonSelected" name="seasonSelected" onchange="initMap()">
                            <option th:value="all" th:text="ทั้งหมด"></option>
                            <option th:each="season : ${seasons}" th:value="${season}" th:text="${season}">
                            </option>
                        </select>
                    </div>
                    <div class="form-group">
                        <label for="">ประเภทคุณภาพสิ่งแวดล้อม</label>
                        <select class="form-control" id="paramASelected" name="paramASelected" onchange="getParamB();">
                            <option th:value="all" th:text="ทั้งหมด"></option>
                            <option th:each="a : ${paramA}" th:value="${a}" th:text="${a}">
                            </option>
                        </select>
                    </div>
                    <div class="form-group">
                        <label for="">พารามิเตอร์ [<span id="standardValue"></span>]</label>
                        <select class="form-control" id="paramBSelected" name="paramBSelected" onchange="searchable()">
                            <option th:value="all" th:text="ทั้งหมด"></option>
                            <option th:each="b : ${paramB}" th:value="${b}" th:text="${b}" >
                            </option>
                        </select>
                    </div>

                    <div id="searchable-gt-lt" style="display: none; font-weight: 600; font-size: 20px;">
                        <div class="form-check form-check-inline ">
                            <input class="form-check-input" type="checkbox" id="gt" value="gt" name="filterByStandard" onchange="initMap()">
                            <label class="form-check-label" for="">สูงกว่ามาตราฐาน</label>
                        </div>
                        <div class="form-check form-check-inline">
                            <input class="form-check-input" type="checkbox" id="lt" value="lt" name="filterByStandard" onchange="initMap()">
                            <label class="form-check-label" for="">ต่ำกว่ามาตราฐาน</label>
                        </div>
                    </div>
                    <div id="searchable-between" style="display: none; font-weight: 600; font-size: 20px;">
                        <div class="form-check form-check-inline ">
                            <input class="form-check-input" type="checkbox" id="btn" value="btn" name="filterByStandard" onchange="initMap()">
                            <label class="form-check-label" for="">อยู่ในช่วงมาตราฐาน</label>
                        </div>
                        <div class="form-check form-check-inline">
                            <input class="form-check-input" type="checkbox" id="notBtn" value="notBtn" name="filterByStandard" onchange="initMap()">
                            <label class="form-check-label" for="">ไม่อยู่ในช่วงมาตราฐาน</label>
                        </div>
                    </div>
                </form>
            </div>
            <div class="col-12 col-xl-9 col-lg-8 col-md-8">
                <div id="map" style="border-radius: 6px;"></div>
            </div>
        </div>
    </div>
    <script>
        function initMap() {
            let standard = "";
            $('input[name="filterByStandard"]:checked').each(function() {
                standard += this.value;
            });

            let tempLocationName = "";
            let tempSampleDate = "";
            let counter = 1;

            let province = $("#provinceSelected option:selected").text();
            let district = $("#districtSelected option:selected").text();
            let tambon = $("#tambonSelected option:selected").text();
            let paramA = $("#paramASelected option:selected").text();
            let paramB = $("#paramBSelected option:selected").text();
            let season = $("#seasonSelected option:selected").text();
            let standardValue = $("#standardValue").text();

            $.ajax({
                method: "POST",
                url: "/api/get-marker",
                data: {
                    district: district,
                    province: province,
                    tambon: tambon,
                    paramA: paramA,
                    paramB: paramB,
                    season: season,
                    standard: standard,
                    standardValue: standardValue
                },
                success: function (response) {
                    console.log(response)
                    let markers = [];


                    for(let i=0; i<response.maps.length; i++) {
                        const arr = [response.maps[i].locationName, response.maps[i].lat, response.maps[i].lon, i];
                        markers.push(arr)
                    }

                    var bounds = new google.maps.LatLngBounds();
                    const map = new google.maps.Map(document.getElementById('map'), {
                        zoom: 12
                    });

                    const shape = {
                        coords: [1, 1, 1, 20, 18, 20, 18, 1],
                        type: "poly"
                    };

                    let image = "";
                    for (let i = 0; i < markers.length; i++) {
                        if(response.maps[i].dataList[0].paramA == 'อากาศ') {
                            image = "/images/air.png";
                        } else if(response.maps[i].dataList[0].paramA == 'ดิน') {
                            image = "/images/dirt.png";
                        } else if(response.maps[i].dataList[0].paramA == 'น้ำผิวดิน') {
                            image = "/images/water.png";
                        }
                        const arr = markers[i];
                        const marker = new google.maps.Marker({
                            position: { lat: arr[1], lng: arr[2] },
                            map,
                            icon: image,
                            shape: shape,
                            title: arr[0],
                            zIndex: arr[3]
                        });

                        bounds.extend(marker.position);

                        attachSecretMessage(marker, response.maps[i].dataList, response.maps[i].locationName);
                    }

                    //now fit the map to the newly inclusive bounds
                    map.fitBounds(bounds);
                }
            });

            // Attaches an info window to a marker with the provided message. When the
            // marker is clicked, the info window will open with the secret message.
            function attachSecretMessage(marker, dataList, locationName) {
                let contentString = `<h5 id="firstHeading" class="firstHeading">${locationName}</h5>
                                     <div style="font-size: 22px">`;

                dataList.sort(sortByName)

                let previousParamA = "";
                for(let i=0; i<dataList.length; i++) {
                    if(previousParamA !== dataList[i].paramA) {
                        previousParamA = dataList[i].paramA
                        contentString += `<b style="font-size: 26px">${dataList[i].paramA}</b><br>`;
                        counter = 1;
                    }

                    if(tempSampleDate !== dataList[i].collectedSampleDate) {

                        contentString += `<br><b style="font-size: 26px">เก็บตัวอย่างครั้งที่ ${counter}</b><br>`;
                        counter++
                    }

                    if(dataList[i].value != null && dataList[i].value != '-') {
                        contentString += `<b>${dataList[i].paramB}:</b> ${dataList[i].value} ${dataList[i].unit}<br>`;
                    }

                    tempLocationName = locationName;
                    tempSampleDate = dataList[i].collectedSampleDate;
                }

                contentString += `</div>`;

                const infowindow = new google.maps.InfoWindow({
                    content: contentString,
                });
                marker.addListener("click", () => {
                    infowindow.open(marker.get("map"), marker);
                });
            }
        }

        function sortByName(a, b) {
            var nameA = a.paramA.toUpperCase(); // ignore upper and lowercase
            var nameB = b.paramA.toUpperCase(); // ignore upper and lowercase
            if (nameA < nameB) {
                return -1;
            }
            if (nameA > nameB) {
                return 1;
            }

            // names must be equal
            return 0;
        }

        function getDistrict() {
            var province = $("#provinceSelected option:selected").text();
            $.ajax({
                method: "POST",
                url: "/get-district",
                contentType: "application/x-www-form-urlencoded;charset=utf-8",
                data: { province: province }
            }).done(function( response ) {
                /////
                $('#tambonSelected').empty();
                var ddl = document.getElementById('tambonSelected');
                var opt = document.createElement('option');
                opt.innerHTML = "ทั้งหมด";
                opt.value = "";
                ddl.appendChild(opt);

                /////
                $('#districtSelected').empty();
                ddl = document.getElementById('districtSelected');
                opt = document.createElement('option');
                opt.innerHTML = "ทั้งหมด";
                opt.value = "";
                ddl.appendChild(opt);

                if(response != null){
                    for(var i = 0; i < response.length; i++) {
                        opt = document.createElement('option');
                        opt.innerHTML = response[i];
                        opt.value = response[i];
                        ddl.appendChild(opt);
                    }
                }

                initMap();
            });
        }

        function getTambon() {
            var province = $("#provinceSelected option:selected").text();
            var district = $("#districtSelected option:selected").text();
            $.ajax({
                method: "POST",
                url: "/get-tambon",
                contentType: "application/x-www-form-urlencoded;charset=utf-8",
                data: {
                    district: district,
                    province: province
                }
            }).done(function (response) {
                //////
                $('#tambonSelected').empty();
                var ddl = document.getElementById('tambonSelected');
                var opt = document.createElement('option');
                opt.innerHTML = "ทั้งหมด";
                opt.value = "";
                ddl.appendChild(opt);

                //////
                if (response != null) {
                    for (var i = 0; i < response.length; i++) {
                        var opt = document.createElement('option');
                        opt.innerHTML = response[i];
                        opt.value = response[i];
                        ddl.appendChild(opt);
                    }
                }

                initMap();
            });
        }

        function getParamB() {
            var paramA = $("#paramASelected option:selected").text();
            $("#searchable-gt-lt").hide();
            $("#searchable-between").hide();
            $("#standardValue").text("")
            $('input[name="filterByStandard"]').attr("checked", false);

            $.ajax({
                method: "POST",
                url: "/get-param-b",
                contentType: "application/x-www-form-urlencoded;charset=utf-8",
                data: {
                    paramA: paramA
                }
            }).done(function (response) {
                //////
                $('#paramBSelected').empty();
                var ddl = document.getElementById('paramBSelected');
                var opt = document.createElement('option');
                opt.innerHTML = "ทั้งหมด";
                opt.value = "";
                ddl.appendChild(opt);

                //////
                if (response != null) {
                    for (var i = 0; i < response.length; i++) {
                        var opt = document.createElement('option');
                        opt.innerHTML = response[i].paramB;
                        opt.value = response[i].paramB;

                        if(response[i].standardValue != "" && null != response[i].standardValue) {
                            opt.dataset.standardValue = response[i].standardValue;
                        }
                        ddl.appendChild(opt);
                    }
                }

                initMap();
            });
        }

        function searchable() {
            $("#searchable-gt-lt").hide();
            $("#searchable-between").hide();
            $("#standardValue").text("")
            $('input[name="filterByStandard"]').attr("checked", false);

            var paramB = $("#paramBSelected option:selected").text();
            $.ajax({
                method: "POST",
                url: "/get-standard",
                contentType: "application/x-www-form-urlencoded;charset=utf-8",
                data: {
                    paramB: paramB
                }
            }).done(function (response) {
                console.log(response)
                if (response != null && response.standardValue != null) {
                    $("#standardValue").text(response.standardValue )
                    if(response.standardValue.includes("-")) {
                        $("#searchable-between").show();
                    } else if(response.standardValue != ""){
                        $("#searchable-gt-lt").show();
                    }
                }

                initMap();
            });
        }
    </script>
    <script defer src="https://maps.googleapis.com/maps/api/js?key=AIzaSyB7ZfCiABLY_5fdhZzlp9MvokgSGZQRBrM&callback=initMap&language=th"></script>
    <div class="" th:include="pages/section/footer :: footer"></div>
</body>
</html>